Index: /ruby/trunk/models/am/archetype/archetype.rb
===================================================================
--- /ruby/trunk/models/am/archetype/archetype.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/archetype.rb	(revision 20)
@@ -7,33 +7,35 @@
 #        include OpenEHR::RM::Support::Terminology::OpenEHR_Code_Set_Identifier
         include OpenEHR::RM::Support::Terminology
-        CURRENT_ADL_VERSION = "1.4"
+        CURRENT_ADL_VERSION = "2.0"
       end
-
-      class ARCHETYPE < OpenEHR::RM::Common::Resource::AUTHORED_RESOURCE
+      class Archetype < OpenEHR::RM::Common::Resource::Authored_Resource
         include ADL_Definition
         attr_accessor :archetype_id, :concept_code, :is_controlled, :original_language, :parent_archtype_id, :uid
 
-        attr_reader :parent_id,:concept, :definition, :ontology
-        attr_accessor :adl_version,:description,:original_language
+        attr_reader :adl_version, :id, :parent_id
+        attr_reader :concept, :definition, :ontology
+        attr_accessor :description,:original_language
         attr_accessor :revision_history, :translation
 
-        def initialize(args = {})
-          @adl_version = args[:adl_version] if args[:adl_version]
-          @archetype_id = args[:archetype_id] ? args[:archetype_id] : nil
-          @parent_id = args[:parent_id] if args[:parent_id]
-          @concept = args[:concept] if args[:concept]
-          @is_controled = args[:is_controled] if args[:is_controled]
-          @definition = args[:definition] if args[:definition]
-          @ontology = args[:ontology] if args[:ontology]
+        def initialize(parent_id, concept,
+                       description, revision_history, is_controled,
+                       definition, ontology, adl_version,
+                       id = nil , original_language = nil, translation = nil)
+#          raise Exception.new("illegal argument error, id == nil") unless id
+#          raise Exception.new("illegal argument error, originalLanguage == nil") unless origina_language
+
+#          raise Exception.new("illegal argument error, translation == nil") unless translation
+          @adl_version = adl_version
+          @id = id
+          @parent_id = parent_id
+          @concept = concept
+          @original_language = original_language
+          @translation = translation
+          @description = description
+          @revision_history = revision_history
+          @is_controled = is_controled
+          @definition = definition
+          @ontology = ontology
  #         loadMaps(definition)
-          super
-        end
-
-        def self.create(args ={}, &block)
-          archetype = new(args)
-          if block_given?
-            yield archetype
-          end
-          return archetype
         end
 
@@ -73,13 +75,8 @@
         def version
         end
-      end # end of ARCHETYPE
+      end
       # original file:
       # ref_imple_eiffel/components/adl_parser/src/interface/adl_definition.e
-
-      class VALIDITY_KIND
-      end
-    end
-
-
+    end # end of Archetype
   end # end of AM
 end # end of OpenEHR
Index: /ruby/trunk/models/am/archetype/archetype_description/archetype_description.rb
===================================================================
--- /ruby/trunk/models/am/archetype/archetype_description/archetype_description.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/archetype_description/archetype_description.rb	(revision 20)
@@ -4,12 +4,9 @@
     module Archetype
       module Archetype_Description
-        class ARCHETYPE_DESCRIPTION
-          attr_accessor :archetype_package_uri, :lifecycle_state, :original_author, :other_contributors, :other_details, :details
-          def initialize(args ={ })
-            @details = args[:details] ? args[:details] : []
-          end
+        class Archetype_Description
+          attr_accessor :archetype_package_uri, :lifecycle_state, :original_author, :other_contributors, :other_details
         end
 
-        class ARCHETYPE_DESCRIPTION_ITEM
+        class Archetype_Description_Item
           attr_accessor :archetype_package_uri, :lifecycle_state, :original_author, :other_contributors, :other_details
         end
Index: /ruby/trunk/models/am/archetype/constraint_model/archetype_constraint.rb
===================================================================
--- /ruby/trunk/models/am/archetype/constraint_model/archetype_constraint.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/constraint_model/archetype_constraint.rb	(revision 20)
@@ -4,105 +4,6 @@
     module Archetype
       module Constraint_Model
-        class ARCHETYPE_CONSTRAINT
+        class Archetype_Constraint
           
-        end
-
-        class CARDINALITY
-          
-        end
-
-        class C_OBJECT < ARCHETYPE_CONSTRAINT
-          attr_accessor :node_id, :occurrences, :rm_type_name
-
-          def initialize(args = { })
-            @node_id = args[:node_id] if args[:node_id]
-            @occurrences = args[:occurrences] if args[:occurrences]
-            @rm_type_name = args[:rm_type_name] if args[:rm_type_name]
-          end
-        end
-
-        class C_ATTRIBUTE < ARCHETYPE_CONSTRAINT
-          attr_accessor :rm_attribute_name, :existence, :children
-
-          def initialize(args = { })
-            @rm_attribute_name = args[:rm_attribute_name] if args[:rm_attribute_name]
-            @existence = args[:existence] if args[:existence]
-            @children = args[:children] ? args[:children] : []
-            
-          end
-        end
-
-        class C_DEFINED_OBJECT < C_OBJECT
-          attr_accessor :assumed_value
-          
-          def initialize(args = { })
-            @assumed_value = args[:assumed_value] if args[:assumed_value]
-            super
-          end
-        end
-
-        class C_PRIMITIVE_OBJECT < C_DEFINED_OBJECT
-          attr_accessor :item
-          
-          def initialize(args = { })
-            @attributes = args[:item] if args[:item]
-            super
-          end
-        end
-
-        class C_COMPLEX_OBJECT < C_DEFINED_OBJECT
-          attr_accessor :attributes, :attributes_valid
-          
-          def initialize(args = { })
-            @attributes = args[:attributes] ? args[:attributes] : []
-            super
-          end
-
-          def self.create(args = { }, &block)
-            c_complex_object = new(args)
-            if block_given?
-              yield c_complex_object
-            end
-            return c_complex_object
-          end
-        end
-
-        class C_DOMAIN_TYPE < C_DEFINED_OBJECT
-          
-        end
-
-        class C_REFERENCE_OBJECT < C_OBJECT
-          
-        end
-
-        class ARCHETYPE_INTERNAL_REF < C_REFERENCE_OBJECT
-          
-        end
-
-        class ARCHETYPE_SLOT < C_REFERENCE_OBJECT
-          
-        end
-
-        class CONSTRAINT_REF < C_REFERENCE_OBJECT
-          
-        end
-
-        class C_SINGLE_ATTRIBUTE < C_ATTRIBUTE
-          attr_accessor :alternatives
-
-          def initialize(args = { })
-            @alternatives = args[:alternatives] ? args[:alternatives] : []
-            super
-          end
-        end
-
-        class C_MULTIPLE_ATTRIBUTE < C_ATTRIBUTE
-          attr_accessor :members, :cardinality
-          
-          def initialize(args = { })
-            @members = args[:members] ? args[:members] : []
-            @cardinality = args[:cardinality] if args[:cardinality]
-            super
-          end
         end
       end
Index: /ruby/trunk/models/am/archetype/constraint_model/assertion.rb
===================================================================
--- /ruby/trunk/models/am/archetype/constraint_model/assertion.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/constraint_model/assertion.rb	(revision 20)
@@ -2,27 +2,8 @@
   module AM
     module Archetype
-      module Assertion
-        class ASSERTION
-        end
-
-        class ASSERTION_VARIABLE
-        end
-
-        class OPERATOR_KIND
-        end
-
-        class EXPR_ITEM
-        end
-
-        class EXPR_LEAF < EXPR_ITEM
-        end
-
-        class EXPR_OPERATOR < EXPR_ITEM
-        end
-
-        class EXPR_UNARY_OPERATOR < EXPR_OPERATOR
-        end
-
-        class EXPR_BINARY_OPERATOR < EXPR_OPERATOR
+      module Constraint_Model
+        module Assertion
+          class Assertion
+          end
         end
       end
Index: /ruby/trunk/models/am/archetype/constraint_model/primitive.rb
===================================================================
--- /ruby/trunk/models/am/archetype/constraint_model/primitive.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/constraint_model/primitive.rb	(revision 20)
@@ -3,8 +3,6 @@
     module Archetype
       module Constraint_Model
-
         module Primitive
-
-          class C_PRIMITIVE
+          class C_Primitive
             def assumed_value
               raise NotImplementedError, "assumed_value should be implemented"
@@ -20,30 +18,30 @@
             end
           end
-
-          class C_BOOLEAN < C_PRIMITIVE
-            attr_reader :true_valid, :false_valid, :assumed_value
-
-            def initialize(args = { })
-              @true_valid = args[:true_valid] ? args[:true_valid] : false
-              @false_valid = args[:false_valid] ? args[:false_valid] : false
-              @assumed_value = args[:assumed_value] ? args[:assumed_value] : false
-              binary_consistency(@true_valid, @false_valid)
+          class C_Boolean < C_Primitive
+            attr_accessor :assumed_value
+            def initialize(true_valid, false_valid, assumed_value)
+              binary_consistency(true_valid, false_valid)
+              @true_valid = true_valid
+              @false_valid = false_valid
+              @assumed_value = assumed_value
             end
-
-            def true_valid=(true_valid)
+            def set_true_valid(true_valid)
               binary_consistency(true_valid, @false_valid)
               @true_valid = true_valid
             end
-
-            def false_valid=(false_valid)
+            def set_false_valid(false_valid)
               binary_consistency(@true_valid,false_valid)
               @false_valid = false_valid 
             end
-
+            def true_valid?
+              @true_valid
+            end
+            def false_valid?
+              @false_valid
+            end
             def valid_value?
               
             end
-
-            def default_value(a_value = nil)
+            def default_value(a_value=nil)
               if a_value == nil
                 @true_valid
@@ -52,7 +50,5 @@
               end              
             end
-
             private 
-
             def binary_consistency(true_valid, false_valid)
               if !true_valid && !false_valid
@@ -61,35 +57,7 @@
             end
           end # of C_Boolean
-
-          class C_STRING < C_PRIMITIVE
+          class C_Integer < C_Primitive
             
           end
-
-          class C_INTEGER < C_PRIMITIVE
-            
-          end
-
-          class C_REAL < C_PRIMITIVE
-            
-          end
-
-          class C_TIME < C_PRIMITIVE
-            
-          end
-
-          class C_DATE < C_PRIMITIVE
-            
-          end
-
-          class C_DATE_TIME < C_PRIMITIVE
-            
-          end
-
-          class C_DURATION < C_PRIMITIVE
-            attr_accessor :years_allowed, :months_allowed, :weeks_allowed, :days_allowed, :hours_allowed, :minutes_allowed, :seconds_allowed, :fractional_seconds_allowed, :range, :assumed_value
-          end
-
-
-
         end # of Primitive
       end # of Constraint_Model
Index: /ruby/trunk/models/am/archetype/ontology.rb
===================================================================
--- /ruby/trunk/models/am/archetype/ontology.rb	(revision 30)
+++ /ruby/trunk/models/am/archetype/ontology.rb	(revision 20)
@@ -3,47 +3,35 @@
     module Archetype
       module Ontology
-        class ARCHETYPE_ONTOLOGY
+        class Archetype_Ontology
           attr_accessor :constraint_codes, :specialisation_depth
           attr_accessor :term_attribute_names, :term_codes
           attr_accessor :terminologies_available
-
           def constraint_binding(a_terminology, a_code)
           end
-
           def constraint_definition(a_lang, a_code)
           end
-
           def has_language?(a_lang)
           end
-
           def has_terminology?(a_terminology)
           end
-
           def term_binding(a_terminology, a_code)
           end
-
           def term_definition(a_lang, a_code)
           end
         end
-
-        class ARCHETYPE_TERM
+        class Archetype_Term
           attr_accessor :code, :items
-
-          def initialize(args = { })
-                         
-            @code = if args[:code]
-                      args[:code]
-                    else
-                      raise ArgumentError, "Code is empty"
-                    end
-            @items = if args[:items]
-                       args[:items]
-                     else
-                       raise ArgumentError, "Items is empty"
-                     end
+          def initialize(code, items)
+            if code == nil
+              raise ArgumentError, "Code is empty"
+            end
+            if items.keys == nil
+              raise ArgumentError, "Items is empty"
+            end
+            @code = code
+            @items = items
           end
-
           def keys
-            @items.keys
+            items.keys
           end
         end
Index: /ruby/trunk/models/am/openehr_profile/data_types/basic.rb
===================================================================
--- /ruby/trunk/models/am/openehr_profile/data_types/basic.rb	(revision 30)
+++ /ruby/trunk/models/am/openehr_profile/data_types/basic.rb	(revision 20)
@@ -1,27 +1,6 @@
 module OpenEHR
-  module AM
+  module RM
     module OpenEHR_Profile
       module Data_Types
-        module Basic
-          class C_DV_STATE
-          end
-
-          class STATE_MACHINE
-          end
-
-          class STATE
-          end
-
-          class TERMINAL_STATE < STATE
-          end
-
-          class NON_TERMINAL_STATE < STATE
-          end
-
-          class TRANSITION
-          end
-        end
-
-        
       end # of Data_Types
     end # of OpenEHR Profile
Index: /ruby/trunk/models/rm.rb
===================================================================
--- /ruby/trunk/models/rm.rb	(revision 30)
+++ /ruby/trunk/models/rm.rb	(revision 20)
@@ -13,21 +13,13 @@
   module RM
     autoload :Demographic, "rm/demographic.rb"
-
     module Common
       autoload :Resource, "rm/common/resource.rb"
     end
-
     module Support
       autoload :Definition, "rm/support/definition.rb"
-
-      module Identification
-        autoload :OBJECT_ID, "rm/support/identification.rb"
-      end
-
       module Terminology
         autoload :Terminology, "rm/support/terminology.rb"
       end
     end
-
     module Data_Types
       autoload :Basic, "rm/data_types/basic.rb"
Index: /ruby/trunk/models/rm/common/resource.rb
===================================================================
--- /ruby/trunk/models/rm/common/resource.rb	(revision 30)
+++ /ruby/trunk/models/rm/common/resource.rb	(revision 20)
@@ -4,41 +4,40 @@
     module Common
       module Resource
-        class AUTHORED_RESOURCE
-          attr_reader :is_controled,:revision_history, :translations
+        class Authored_Resource
+          attr_reader :is_controled
+          attr_reader :revision_history, :translations
           attr_accessor :description, :original_language
-
-          def initialize(args = { })
-            @original_language = args[:original_language] if args[:original_language]
-            @translations = args[:translations] if args[:translations]
-            @revision_history = args[:revision_history] ? args[:revision_history] : nil
-
-            unless @revision_history
-              @is_controled = false
+          def initialize(original_language, translations,
+                         description, revision_history = nil)
+            if original_language == nil
+              raise Exception.new("original language nil")
+            end
+            if translations == nil
+              raise Exception.new("translation empty")
+            end
+            if revision_history == nil
+              is_controled = false
             else
-              @is_controled = true
+              is_controled = true
             end
-
-            @original_language = args[:original_language] if args[:original_language]
-            @translations = args[:translations] if args[:translations]
-            @description = args[:description] if args[:description]
+            @original_language = original_language
+            @translations = translations
+            @description = description
+            @revision_history = revision_history
           end
-
           def current_version
             @revision_history.most_recent_revision
           end
-
           def language_available
             languages = Set.new
-            if @translations != nil
-              languages << @translations.keys
+            if translations != nil
+              languages << translations.keys
             end
-            languages << @original_language.code_string
+            languages << original_language.code_string
           end
         end
-
-        class TRANSLATION_DETAILS
+        class Translation_Details
           attr_accessor :language, :author, :accreditation
           attr_accessor :other_details, :terminology_service
-
           def initialize(language, author, accreditation, other_details,
                          terminology_service)
Index: /ruby/trunk/models/rm/support/identification.rb
===================================================================
--- /ruby/trunk/models/rm/support/identification.rb	(revision 30)
+++ /ruby/trunk/models/rm/support/identification.rb	(revision 20)
@@ -2,46 +2,36 @@
   module RM
     module Support
-      module Identification
-
-        class OBJECT_ID
+      module Definition
+        class Object_ID
           attr_accessor :value
-
           def initiallize(value)
-            raise "empty value" unless value
+            if value == nil
+              raise Exception.new("empty value")
+            end
             @value = value
           end
         end # of ObjectID
-
-        class ARCHETYPE_ID < OBJECT_ID
-        end
-
-        class TERMINOLOGY_ID < OBJECT_ID
+        class Terminology_ID < Object_ID
           attr_reader :name
-
-          def initialize(name , version_id)
-            @name , @version_id = name , version_id
-#             if arg1 == nil
-#               super(arg0)
-#             else
-#               super(toValue(arg0, arg1))
-#               @name = arg0
-#               @version = arg1      
-#             end
+          def initialize(arg0, arg1=nil)
+            if arg1 == nil
+              super(arg0)
+            else
+              super(toValue(arg0, arg1))
+              @name = arg0
+              @version = arg1      
+            end
           end
-
           def setValue(value)
             loadValue(value)
             super.value = value
           end
-
           def version_id
             @version
           end
-
           private
-
           def loadValue(value)
             if /\(.*\)$/ =~ value
-#              @name, @version = value.split(\())
+              @name, @version = value.split(\())
               @version.chop!
             else
@@ -50,5 +40,4 @@
             end
           end
-
           def toValue(name, version)
             if name == ""
